//+------------------------------------------------------------------+
//|                                                    ShadowsTF.mq4 |
//|                                                  Dmitry Yakovlev |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Dmitry Yakovlev, Russia, Omsk, mar 2009"
#property link      "http://fehu.by.ru/index.html"

#property indicator_chart_window
//---- input 
//extern string    _tf=" ():";
extern int       tf=1440;
//extern string    _idepth="- , 0-";
extern int       idepth=10;
extern bool      Day_OfWeek = true;
//extern string    _hilo=" High/Low, Up, Down";
extern color     HiLoColor=Maroon;
extern color     UpColor=DarkGreen;
extern color     DnColor=Brown;
//extern string    _donate1="  :-) WebMoney";
//extern string    _donate2="R865705290089";

int depth,Day_Of_Week;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
//---- indicators
   if(idepth>0)depth=idepth;
   else depth=Bars;
     
   deleteAll();
   if(tf<=Period())
   {
      if(Period()==PERIOD_M1) tf=PERIOD_M5;
      if(Period()==PERIOD_M5) tf=PERIOD_M15;
      if(Period()==PERIOD_M15) tf=PERIOD_M30;
      if(Period()==PERIOD_M30) tf=PERIOD_H1;
      if(Period()==PERIOD_H1) tf=PERIOD_H4;
      if(Period()==PERIOD_H4) tf=PERIOD_D1;
      if(Period()==PERIOD_D1) tf=PERIOD_W1;
   }
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
//----
   if(idepth==0) depth=Bars;
   deleteAll();
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   if(Day_OfWeek&&tf==1440)depth=DayOfWeek();
   int    counted_bars=IndicatorCounted();
   int i=0;
   datetime t1,t2;
   double p1,p2,p3,p4;
   if(idepth==0) depth=(Bars-counted_bars)*Period()/tf;
//----
   deleteAll();
   for(i=0;i<depth;i++)
   {
      t1=iTime(Symbol(),tf,i);
      t2=iTime(Symbol(),tf,i)+tf*60;
      p1=iHigh(Symbol(),tf,i);
      p2=iLow(Symbol(),tf,i);
      p3=iOpen(Symbol(),tf,i);
      p4=iClose(Symbol(),tf,i);
      
      drawCandle(i,t1,t2,p1,p2,p3,p4);
   }
//----
   return(0);
}
//+------------------------------------------------------------------+
void drawCandle(int n,int t1,int t2, double p1, double p2, double p3, double p4)
{
   string n1="canhi_"+DoubleToStr(tf,0)+"_"+DoubleToStr(n,0);
   string n2="canopcl_"+DoubleToStr(tf,0)+"_"+DoubleToStr(n,0); 
   string n3="canlo_"+DoubleToStr(tf,0)+"_"+DoubleToStr(n,0); 
   color clr=UpColor;
   
   if(p4>p3) 
   {
      double sw=p3;
      p3=p4;
      p4=sw;
      clr=UpColor;
   }
   else
      clr=DnColor;
   
   ObjectCreate(n1, OBJ_RECTANGLE, 0, t1, p1, t2, p3);
   ObjectSet(n1, OBJPROP_COLOR, HiLoColor);
   ObjectSet(n1,OBJPROP_BACK,true);
   ObjectSet(n1,OBJPROP_WIDTH,1);
   ObjectSet(n1,OBJPROP_STYLE,0);

   ObjectCreate(n2, OBJ_RECTANGLE, 0, t1, p3, t2, p4);
   ObjectSet(n2, OBJPROP_COLOR, clr);
   ObjectSet(n2,OBJPROP_BACK,true);
   ObjectSet(n2,OBJPROP_WIDTH,1);
   ObjectSet(n2,OBJPROP_STYLE,0);

   ObjectCreate(n3, OBJ_RECTANGLE, 0, t1, p4, t2, p2);
   ObjectSet(n3, OBJPROP_COLOR, HiLoColor);
   ObjectSet(n3,OBJPROP_BACK,true);
   ObjectSet(n3,OBJPROP_WIDTH,1);
   ObjectSet(n3,OBJPROP_STYLE,0);
}

void deleteAll()
{
   for(int i=0;i<depth;i++)
   {
      ObjectDelete("canhi_"+DoubleToStr(tf,0)+"_"+DoubleToStr(i,0));
      ObjectDelete("canopcl_"+DoubleToStr(tf,0)+"_"+DoubleToStr(i,0));
      ObjectDelete("canlo_"+DoubleToStr(tf,0)+"_"+DoubleToStr(i,0));
   }
}

